package de.oose.trainings.oot.junit.geometrie;

import junit.framework.*;

public class TestDreieck extends TestCase {
  private double delta = 0.001;
  private Dreieck aDr = null;

  public TestDreieck(String name) {
    super(name);
  }

  protected void setUp() throws Exception {
    super.setUp();
    aDr = new Dreieck(1,1,1);
  }

  protected void tearDown() throws Exception {
    aDr = null;
    super.tearDown();
  }

  public void testDreieck() {
    double kanteA = 1;
    double kanteB = 1;
    double kanteC = 1;
    Dreieck dreieck = new Dreieck(kanteA, kanteB, kanteC);
    assertEquals(kanteA,dreieck.getKanteA(),delta);
    assertEquals(kanteB,dreieck.getKanteB(),delta);
    assertEquals(kanteC,dreieck.getKanteC(),delta);
  }

  public void testSetKanten() {
    double kanteA = 1;
    double kanteB = 1;
    double kanteC = 1;
    aDr.setKanten(kanteA, kanteB, kanteC);
    assertEquals(kanteA,aDr.getKanteA(),delta);
    assertEquals(kanteB,aDr.getKanteB(),delta);
    assertEquals(kanteC,aDr.getKanteC(),delta);
    kanteA = 3;
    kanteB = 3;
    kanteC = 3;
    aDr.setKanten(kanteA, kanteB, kanteC);
    assertEquals(kanteA,aDr.getKanteA(),delta);
    assertEquals(kanteB,aDr.getKanteB(),delta);
    assertEquals(kanteC,aDr.getKanteC(),delta);
  }

  public void testCheckDreieck(){
    assertTrue(Dreieck.checkDreieck(3,4,5));
    assertTrue(Dreieck.checkDreieck(3,5,5));
    assertTrue(Dreieck.checkDreieck(5,5,5));
    assertTrue(Dreieck.checkDreieck(2,4,5));
    assertTrue(Dreieck.checkDreieck(3.50,3.51,7.00));

    assertFalse(Dreieck.checkDreieck(1,4,5));
    assertFalse(Dreieck.checkDreieck(1,0,1));
    assertFalse(Dreieck.checkDreieck(5,3,2));
    assertFalse(Dreieck.checkDreieck(3.50,3.50,7.00));
  }

  public void testFlaeche(){
    aDr.setKanten(4, 6, 7.2);
    assertEquals(aDr.flaeche(), 12.0, delta);
  }

  public void testGleichseitig(){
    aDr.setKanten(4.0009, 3.9999, 4.0000);
    assertTrue(aDr.isGleichseitig());
    aDr.setKanten(4, 3.998, 4);
    assertFalse(aDr.isGleichseitig());
  }

  public void testGleichschenklig(){
    aDr.setKanten(3.998, 4.0009, 3.99999);
    assertTrue(aDr.isGleichschenklig());
    aDr.setKanten(4.0000, 4, 4.0009);
    assertFalse(aDr.isGleichschenklig());
  }

}
